/* Priority queues, implemented as heaps
 * C version
 *
 * 15-122 Principles of Imperative Computation, Fall 2012
 * Frank Pfenning
 */
#include <stdbool.h>

#ifndef _HEAPS_H_
#define _HEAPS_H_

/* Client interface */

typedef struct htree_node* elem;  /* element - specialized to huffman trees */

int elem_priority(elem e);        /* client-specified priority function */

/* Library interface */

typedef struct heap_header* pq;

pq pq_new(int capacity);
bool pq_empty(pq P);
bool pq_full(pq P);
void pq_insert(pq P, elem e);	/* P not full */
elem pq_min(pq P);		/* P not empty */
elem pq_delmin(pq P);		/* P not empty */
void pq_free(pq P);		/* P empty! */

#endif /* _HEAPS_H_ */
